'This Module contains the subroutines for Lotus like lightbar menuing.
'It uses the $INCLUDE files named SCANDEF and MENULIST.
'SCANDEF contains the declareations for this module and needs to be
'included in any module that calls procedures from this module.
'MENULIST is a data list that contains the information about the menu
'used in any module that calls this one.

'$INCLUDE: 'menu.def'
'$INCLUDE: 'MENU.lst'

DIM SHARED index(0 TO 9, 2) AS INTEGER

SUB clearmenu

        LOCATE row, 1: PRINT SPACE$(79)
        LOCATE row + 2, 1: PRINT SPACE$(79)
       
END SUB

'This function returns the users selection and manages the light bar
'of the menu.  Your program should call this function and then execute
'a SELECT CASE choice.
'
'
'
FUNCTION getchoice (choice)
        DO
        x$ = INKEY$
        LOOP WHILE x$ = ""
       
        a$ = (MID$(x$, 1, 1))
        b$ = (MID$(x$, 2, 1))
        IF a$ <> "" THEN choice = ASC(a$)
        IF b$ <> "" THEN choice = ASC(b$) + 200
       
        CALL normal
        SELECT CASE choice

                CASE 13
                        choice = ASC(LEFT$(menu(cmdno).title, 1))
                CASE 277
                        cmdno = cmdno + 1
                CASE 275
                        cmdno = cmdno - 1
                CASE ELSE
                        FOR i = 0 TO maxcmd
                                compare = ASC(LEFT$(menu(i).title, 1))
                                IF compare = choice THEN cmdno = i
                                IF compare = (choice - 32) THEN cmdno = i
                        NEXT i
                       
        END SELECT
       
        IF cmdno > maxcmd THEN cmdno = 0
        IF cmdno < 0 THEN cmdno = maxcmd
        CALL highlight
        CALL whatis


       

END FUNCTION

SUB highlight


       
        LOCATE row, menu(cmdno).column
        COLOR menu(cmdno).bcolor, menu(cmdno).fcolor
        PRINT RTRIM$(menu(cmdno).title)
        COLOR menu(cmdno).fcolor, menu(cmdno).bcolor

END SUB

SUB normal


        LOCATE row, menu(cmdno).column
        COLOR menu(cmdno).fcolor, menu(cmdno).bcolor
        PRINT RTRIM$(menu(cmdno).title)
        
END SUB

SUB setmenu (newmenu AS INTEGER, enter AS INTEGER, alone AS INTEGER)

'This is the routine that sets the current menu and manages the menu
'stack when using multiple level menus.

STATIC stack

        IF stack = 0 THEN stack = 1
        SELECT CASE enter
                CASE 1
                        index(stack, 1) = menuno
                        index(stack, 2) = cmdno
                        
                        IF alone THEN CALL clearmenu
                        stack = stack + 1
                        cmdno = index(stack, 2)
                        menuno = newmenu
                CASE 0
                        IF alone THEN CALL clearmenu
                        index(stack, 2) = cmdno
                        stack = stack - 1
                        IF NOT newmenu THEN
                                menuno = index(stack, 1)
                                cmdno = index(stack, 2)
                        ELSE
                                menuno = newmenu
                        END IF
                CASE ELSE
        END SELECT
       

        SELECT CASE menuno
                CASE 1
                        RESTORE menu1:
                CASE 2
                        RESTORE menu2:
                CASE 3
                        RESTORE menu3:
                CASE 4
                        RESTORE menu4:
                CASE 5
                        RESTORE menu5:
                CASE 6
                        RESTORE menu6:
                CASE 7
                        RESTORE menu7:
                CASE 8
                        RESTORE menu8:
                CASE 9
                        RESTORE menu9:
                CASE 10
                        RESTORE menu10:
                CASE ELSE
                        RESTORE

        END SELECT
       
        READ maxcmd
        READ row
        READ basecolumn
        column = basecolumn

        FOR i = 0 TO maxcmd
                READ menu(i).title
                READ menu(i).fcolor
                READ menu(i).bcolor
                READ menu(i).description
                place$ = RTRIM$(menu(i).title)
                menu(i).column = column
                column = column + (2 + LEN(place$))
        NEXT i

        CALL showmenu
        CALL highlight
        CALL whatis


END SUB

SUB showmenu

        FOR i = 0 TO maxcmd
                menulength = menulength + LEN(RTRIM$(menu(i).title))
        NEXT i

        LOCATE row, menu(cmdno).column: PRINT SPACE$(menulength)
        LOCATE row + 2, menu(cmdno).column: PRINT SPACE$(menulength)
       
        FOR i = 0 TO maxcmd
                LOCATE row, menu(i).column
                COLOR menu(i).fcolor, menu(i).bcolor
                PRINT RTRIM$(menu(i).title)

        NEXT i

END SUB

SUB whatis
     LOCATE row + 2, basecolumn
     PRINT menu(cmdno).description
END SUB

